<?xml version="1.0" encoding="utf-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="generator" content="Docutils 0.5: http://docutils.sourceforge.net/" />
<title>Vomak</title>
<meta name="authors" content="Enrico Tröger  Dominic Hopf" />
<meta name="date" content="2008-06-24" />
<style type="text/css">

/*
:Author: Enrico Troeger
:Contact: enrico(dot)troeger(at)uvena(dot)de
:Copyright: This stylesheet has been placed in the public domain.

Stylesheet for Geany's documentation based on a version of John Gabriele.
*/

/*@import url(html4css1.css);*/

body {
    background-color: #f2f2f2;
    color: #404040;
	margin-left: 0.4em;
    width: 60em;
    font-size: 90%;
}

a {
    color: #000099;
}

a:visited {
    color: #000099;
}

a:hover {
    text-decoration: none;
}

h1 {
    border-top: 1px dotted;
    margin-top: 2em;
}

h1, h2, h3 {
    font-family: sans-serif;
}

h1.title {
  text-align: left }

h2 {
    margin-top: 30px;
}

h2.subtitle {
  text-align: left }

h3 {
    padding-left: 3px;
}

blockquote, pre {
    border: 1px solid;
    padding: 0.4em;
}

blockquote {
    font-family: sans-serif;
    background-color: #DBEDD5;
    border: 1px dotted;
    border-left: 4px solid;
    border-color: #9FD98C;
}

pre {
    background-color: #ECDFCE;
    border: 1px dotted;
    border-left: 4px solid;
    border-color: #D9BE9A;
}

tt, pre, code {
    color: #6D1260;
}

table {
    border: 1px solid #200067;
}

th {
    border: 1px dotted #200067;
}

td {
    border: 1px dotted #200067;
}

.docinfo-name {
	color: #0000ff;
}

p.admonition-title {
	color: #0000ff;
	font-weight: bold;
}

div.note {
	margin: 1em 3em;
	padding: 0em;
}

dt {
	font-style: italic;
}

</style>
</head>
<body>
<div class="document" id="vomak">
<h1 class="title">Vomak</h1>
<h2 class="subtitle" id="a-very-simple-irc-bot">A very simple IRC bot</h2>
<table class="docinfo" frame="void" rules="none">
<col class="docinfo-name" />
<col class="docinfo-content" />
<tbody valign="top">
<tr><th class="docinfo-name">Authors:</th>
<td>Enrico Tröger
<br />Dominic Hopf</td></tr>
<tr><th class="docinfo-name">Date:</th>
<td>2008-06-24</td></tr>
<tr><th class="docinfo-name">Version:</th>
<td>0.1</td></tr>
</tbody>
</table>
<p>Copyright © 2008</p>
<p>Vomak is distributed under the terms of the GNU General Public
License as published by the Free Software Foundation; version 2
of the License. A copy of this license can be found in the file
COPYING included with the source code of this program.</p>
<div class="section" id="big-fat-warning">
<h1>BIG FAT WARNING</h1>
<p>This code is not well tested and probably runs only on GNU/Linux systems.
There has no work been made in being compatible with other systems nor
being very secure.
This whole code was just written to get an IRC bot working and only was
published in case anyone might find it useful. The code quality is also
not very good, comments are missing.
It does not very much error checking, consider it running unstable.
This document is the only documentation available besides the source code.</p>
<p>You have been warned.</p>
</div>
<div class="section" id="about">
<h1>About</h1>
<p>Vomak is a very simple IRC bot with a few basic features.
It connects to an IRC server and joins a channel. Then it waits for
commands like <tt class="docutils literal"><span class="pre">??</span> <span class="pre">keyword</span></tt>. This is the built-in help system, see
<a class="reference internal" href="#help-system">Help System</a>.
Additionally, the bot creates a socket (Unix Domain Socket) where it
accepts directly IRC messages and a few special commands, see
<a class="reference internal" href="#socket-communication">Socket Communication</a>.</p>
</div>
<div class="section" id="get-the-code">
<h1>Get the code</h1>
<p>The source code is maintained in a GIT repository.</p>
<p>GIT clone URL: <a class="reference external" href="http://repo.or.cz/r/vomak.git">http://repo.or.cz/r/vomak.git</a></p>
<p>GIT web interface: <a class="reference external" href="http://repo.or.cz/w/vomak.git">http://repo.or.cz/w/vomak.git</a></p>
<p>For downloading a tarball, use the web interface. There is a link
<tt class="docutils literal"><span class="pre">snapshot</span></tt> which you can use to download a generated tarball og
any commit.</p>
</div>
<div class="section" id="installation">
<h1>Installation</h1>
<p>To compile the code, run the following two commands:</p>
<pre class="literal-block">
./waf configure
./waf build
</pre>
<p>If everything went fine, you should have an executable called <tt class="docutils literal"><span class="pre">vomak</span></tt>
in the directory build/default.</p>
</div>
<div class="section" id="configuration">
<h1>Configuration</h1>
<p>Vomak expects two configuration files in the ~/.vomak.
The first is <tt class="docutils literal"><span class="pre">config</span></tt> and defines basic settings for operation.
The settings should be self-explanatory.
The second file is <cite>database</cite> which contains all definitions for the
built-in help system. The format is pretty simple, each line contains
a key-value pair. The key should not contain whitespaces, quotes or any
special characters. The values can contain any characters except line
breaks. To add a line break, escape it with <tt class="docutils literal"><span class="pre">\n</span></tt>.
Each defined key-value pair can later be queried with the command
<tt class="docutils literal"><span class="pre">??</span> <span class="pre">key</span></tt>.
Examples of both files are included in the source code.</p>
</div>
<div class="section" id="help-system">
<h1>Help System</h1>
<p>The built-in help system is a handy way to access often used information and
print them in the current channel for all users. It is triggered by two question
marks followed by a space and the keyword to search.
If the keyword is not known, nothing happens.
If it is known, Vomak will print the corresponding help text found in its database.
The database is a simple text file with some pre-defined help texts, see
<a class="reference internal" href="#configuration">Configuration</a> above.
There is a special keyword named <tt class="docutils literal"><span class="pre">keywords</span></tt> which lists all known keywords.</p>
</div>
<div class="section" id="socket-communication">
<h1>Socket Communication</h1>
<p>A Unix Domain Socket is created once Vomak has start up and it is meant for
inter-process communication with other applications running on this host.
Please be careful with connecting clients: the opened socket connection should
be closed as soon as all commands are sent and possible answers have been read.
The socket is non-blocking, i.e. while a client connects to the socket, Vomaks
main operation(reading and processing IRC messages) is blocked.
All commands are line-based, i.e. answers are terminated with <tt class="docutils literal"><span class="pre">\r\n</span></tt> and you
should your commands terminate with a <tt class="docutils literal"><span class="pre">\r\n</span></tt>.
Vomak accepts direct IRC messages (e.g. <tt class="docutils literal"><span class="pre">PRIVMSG</span> <span class="pre">#channel</span> <span class="pre">:text</span> <span class="pre">to</span> <span class="pre">send</span></tt>) or
the following special commands:</p>
<ul class="simple">
<li>userlist</li>
<li>reload</li>
<li>openlog</li>
<li>quit</li>
</ul>
<div class="section" id="userlist">
<h2>userlist</h2>
<p>After sending this command to the socket, it will answer with a space separated
list of currently connected users to current channel.
Vomak caches this list for performance reasons and updates it every three minutes.</p>
</div>
<div class="section" id="reload">
<h2>reload</h2>
<p>This command performs a reload of the database with the help texts. This is useful
when you want to add, edit or remove some help texts and don't want to quit and start
Vomak again.</p>
</div>
<div class="section" id="openlog">
<h2>openlog</h2>
<p>Closes the logfile handle and open it again. This can be used to do some log rotating
or to just clearing the logfile. This can also achieved by the SIGHUP signal.</p>
</div>
<div class="section" id="quit">
<h2>quit</h2>
<p>Does a graceful shutdown of the program. This can also achieved by the SIGTERM or SIGINT
signals. The <tt class="docutils literal"><span class="pre">quit</span></tt> command accepts an arbitrary amount of additional arguments, these
will be passed to Vomak and used as the IRC QUIT message.</p>
</div>
</div>
</div>
<div class="footer">
<hr class="footer" />
<a class="reference external" href="README">View document source</a>.
Generated on: 2008-10-22 18:27 UTC.
Generated by <a class="reference external" href="http://docutils.sourceforge.net/">Docutils</a> from <a class="reference external" href="http://docutils.sourceforge.net/rst.html">reStructuredText</a> source.

</div>
</body>
</html>
